## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 19;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Generated by go2rpm 1.8.0
%bcond_without check

# https://github.com/docker/distribution
%global goipath         github.com/docker/distribution
Version:                2.8.1
%global tag             v%{version_no_tilde}

%gometa -f

%global common_description %{expand:
The Docker toolset to pack, ship, store, and deliver content.

This repository's main product is the Docker Registry 2.0 implementation for
storing and distributing Docker images. It supersedes the docker/docker-registry
project with a new API design, focused around security and performance.}

%global golicenses      LICENSE
%global godocs          docs BUILDING.md CONTRIBUTING.md README.md ROADMAP.md

Name:           %{goname}
Release:        %autorelease -e 0.riscv64
Summary:        Docker toolkit to pack, ship, store, and deliver container content

License:        Apache-2.0
URL:            %{gourl}
Source:         %{gosource}
Patch:          0001-Partial-backport-of-8f9c809.patch
Patch:          0002-Partial-backport-of-907e7be.patch

%description %{common_description}

%gopkg

%prep
%goprep -A
%autopatch -p1

%generate_buildrequires
%go_generate_buildrequires

%build
for cmd in cmd/* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
%ifarch riscv64
%global gotestflags %{gotestflags} -timeout 30m
%endif

for test in "TestHTTPChecker" \
            "TestFileReaderSeek" \
            "TestListObjectsV2" \
            "TestGracefulShutdown" \
; do
awk -i inplace '/^func.*'"$test"'\(/ { print; print "\tt.Skip(\"disabled failing test\")"; next}1' $(grep -rl $test)
done
%if 0%{?__isa_bits} == 32
%gocheck -d registry/storage/driver/inmemory \
         -d registry/handlers \
         -d registry/storage/driver/swift \
         -d registry/storage/driver/filesystem
%else
%gocheck -d registry/storage/driver/inmemory \
         -d registry/handlers
%endif
%endif

%files
%license LICENSE
%doc docs BUILDING.md CONTRIBUTING.md README.md ROADMAP.md
%{_bindir}/digest
%{_bindir}/registry-api-descriptor-template
%{_bindir}/registry

%gopkgfiles

%changelog
## START: Generated by rpmautospec
* Wed Jan 15 2025 David Abdurachmanov <davidlt@rivosinc.com> - 2.8.1-19.0.riscv64
- Increase timeout 10m -> 30m for riscv64

* Wed Jan 15 2025 David Abdurachmanov <davidlt@rivosinc.com> - 2.8.1-18
- RPMAUTOSPEC: unresolvable merge
## END: Generated by rpmautospec
